;	start.asm for the GBA
;	Eloist (eloist@gmx.de)
;
; 	modified for the goldroad assembler  /Mic



@define Cpu_Mode_USR 0x10
@define Cpu_Mode_IRQ 0x12
@define Cpu_Mode_SVC 0x13

@define Cpu_Stack_USR 0x03007F00	; GBA USR stack adress
@define Cpu_Stack_IRQ 0x03007FA0	; GBA IRQ stack adress
@define Cpu_Stack_SVC 0x03007FE0	; GBA SVC stack adress
	
b 	bootcode
@DCD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
@DCD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
@DCD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

bootcode
	mov 	r0, Cpu_Mode_IRQ
	orr r0,r0,0x80
	orr r0,r0,0x40			; Disable interrupts
	msr 	cpsr, r0		; Enable IRQ mode
	ldr 	r13, =Cpu_Stack_IRQ	; Setup IRQ stack pointer

	mov 	r0, Cpu_Mode_SVC
	orr r0,r0,0x80
	orr r0,r0,0x40		 	; Disable interrupts
	msr 	cpsr, r0		; Enable SVC mode
	ldr 	r13, =Cpu_Stack_SVC	; Setup SVC stack pointer


	mov 	r0, Cpu_Mode_SVC
	orr r0,r0,0x40			; Only IRQ enabled
	msr 	cpsr, r0
	
	mov 	r0, Cpu_Mode_USR
	orr r0,r0,0x80
	orr r0,r0,0x40	
	msr cpsr, r0			; Switch to USR mode
	ldr sp, =Cpu_Stack_USR		; Setup USR stack pointer
		
	b	start		
	@ltorg

 	
 	